/*
 * Created on 27.09.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gnu.java.beans.decoder;

import java.lang.reflect.Array;

/** A Context implementation for a fixed size array. The array
 * elements have to be set using IndexContext instances.
 *
 * @author Robert Schuster
 */
class ArrayContext extends AbstractContext
{
  private Object array;

  ArrayContext(String id, Class klass, int length)
  {
    setId(id);
    array = Array.newInstance(klass, length);
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#addObject(java.lang.Object)
   */
  public void addParameterObject(Object o) throws AssemblyException
  {
    throw new AssemblyException(new IllegalStateException("Adding objects without an index to a fixed array is not possible."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#reportStatement()
   */
  public void notifyStatement(Context outerContext)
  {
    // ignore
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#endContext(gnu.java.beans.decoder.Context)
   */
  public Object endContext(Context outerContext) throws AssemblyException
  {
    return array;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#subContextFailed()
   */
  public boolean subContextFailed()
  {
    // returns false to indicate that assembling the array does not fail only because
    // a subelement failed.
    return false;
  }

  public void set(int index, Object o) throws AssemblyException
  {
    try
      {
	Array.set(array, index, o);
      }
    catch (ArrayIndexOutOfBoundsException aioobe)
      {
	throw new AssemblyException(aioobe);
      }
  }

  public Object get(int index) throws AssemblyException
  {
    try
      {
	return Array.get(array, index);
      }
    catch (ArrayIndexOutOfBoundsException aioobe)
      {
	throw new AssemblyException(aioobe);
      }
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#getResult()
   */
  public Object getResult()
  {
    return array;
  }
}
