/*
 * Created on 27.09.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gnu.java.beans.decoder;

import java.beans.XMLDecoder;
import java.util.ArrayList;
import java.util.Iterator;

/** DecoderContext is a Context implementation which allows access to the XMLDecoder instance
 * itself. This is used for the <java> tag.
 *
 * @author Robert Schuster
 */
public class DecoderContext extends AbstractContext
{
  private XMLDecoder decoder;

  public DecoderContext(XMLDecoder xmlDecoder)
  {
    decoder = xmlDecoder;
  }

  private ArrayList objects = new ArrayList();

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#addObject(java.lang.Object)
   */
  public void addParameterObject(Object o) throws AssemblyException
  {
    objects.add(o);
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#reportStatement()
   */
  public void notifyStatement(Context outerContext) throws AssemblyException
  {
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#endContext(gnu.java.beans.decoder.Context)
   */
  public Object endContext(Context outerContext) throws AssemblyException
  {
    return decoder;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#subContextFailed()
   */
  public boolean subContextFailed()
  {
    return false;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#set(int, java.lang.Object)
   */
  public void set(int index, Object o) throws AssemblyException
  {
    throw new AssemblyException(new IllegalArgumentException("Set method is not allowed in decoder context."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#get(int)
   */
  public Object get(int index) throws AssemblyException
  {
    throw new AssemblyException(new IllegalArgumentException("Get method is not allowed in decoder context."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#getResult()
   */
  public Object getResult()
  {
    return decoder;
  }

  public Iterator iterator()
  {
    return objects.iterator();
  }
}
