/*
 * Created on 05.10.2004
 *
 */


package gnu.java.beans.decoder;

import java.beans.ExceptionListener;

import org.xml.sax.Attributes;

/** An ElementHandler implementation that is used as an artificial root
 * element. This avoids having to check for a null element.
 *
 * @author Robert Schuster
 */
class DummyHandler implements ElementHandler
{
  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#start(org.xml.sax.Attributes, java.beans.ExceptionListener)
   */
  public void start(Attributes attributes, ExceptionListener exceptionListener)
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#end(java.beans.ExceptionListener)
   */
  public void end(ExceptionListener exceptionListener)
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#characters(char[], int, int)
   */
  public void characters(char[] ch, int start, int length)
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#isSubelementAllowed(java.lang.String)
   */
  public boolean isSubelementAllowed(String subElementName)
  {
    return true;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#instantiateClass(java.lang.String)
   */
  public Class instantiateClass(String className)
    throws ClassNotFoundException
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#reportStatement(java.beans.ExceptionListener)
   */
  public void notifyStatement(ExceptionListener exceptionListener)
  {
    // ignore
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#hasFailed()
   */
  public boolean hasFailed()
  {
    return false;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#getContext()
   */
  public Context getContext()
  {
    return new DummyContext();
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#contextFailed()
   */
  public void notifyContextFailed()
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#putObject(java.lang.String, java.lang.Object)
   */
  public void putObject(String objectId, Object o)
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.ElementHandler#getObject(java.lang.String)
   */
  public Object getObject(String objectId)
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }

  public ElementHandler getParent()
  {
    throw new InternalError("This handler must not be called. Please send a bug report.");
  }
}
