/*
 * Created on 27.09.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gnu.java.beans.decoder;


/** IndexContext is Context implementation that senses whether it is an indexed get or set
 * operation and invokes this operation.
 *
 * An IndexContent is a get operation when no argument is provided and a set operation if one
 * argument is provided.
 *
 * @author Robert Schuster
 */
class IndexContext extends AbstractContext
{
  private Object result;
  private Object argument;
  private int index;
  private boolean isSetter;

  IndexContext(String id, int newIndex)
  {
    setId(id);
    index = newIndex;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#addObject(java.lang.Object)
   */
  public void addParameterObject(Object o) throws AssemblyException
  {
    if (! isSetter)
      {
	argument = o;
	isSetter = true;
      }
    else
      throw new AssemblyException(new IllegalStateException("More than one argument for indiced access is not possible."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#reportStatement()
   */
  public void notifyStatement(Context outerContext) throws AssemblyException
  {
    throw new AssemblyException(new IllegalStateException("Statements inside indiced access are not allowed."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#endContext(gnu.java.beans.decoder.Context)
   */
  public Object endContext(Context outerContext) throws AssemblyException
  {
    if (isSetter)
      {
	// setter
	outerContext.set(index, argument);

	return null;
      }
    else
      // getter
      return result = outerContext.get(index);
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#subContextFailed()
   */
  public boolean subContextFailed()
  {
    // returns true to indicate that indiced access assembly fails when one of its
    // argument could not be assembled
    return true;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#set(int, java.lang.Object)
   */
  public void set(int index, Object o) throws AssemblyException
  {
    throw new AssemblyException(new IllegalStateException("Setter is not allowed inside indiced access."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#get(int)
   */
  public Object get(int index) throws AssemblyException
  {
    throw new AssemblyException(new IllegalStateException("getter is not allowed insided indiced access."));
  }

  public Object getResult()
  {
    return result;
  }
}
