/*
 * Created on 24.09.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gnu.java.beans.decoder;

import java.beans.ExceptionListener;
import java.util.HashMap;

import org.xml.sax.Attributes;

/** Wraps a DecoderContext instance.
 *
 * @author Robert Schuster
 */
public class JavaHandler extends AbstractElementHandler
{
  private Context context;
  private HashMap objectMap = new HashMap();
  private ClassLoader classLoader;

  /**
   * @param PersistenceParser
   */
  JavaHandler(DummyHandler parent, Context decoderContext,
              ClassLoader cl)
  {
    super(parent, true);

    classLoader = cl;

    context = decoderContext;

  }

  protected Context startElement(Attributes attributes, ExceptionListener exceptionListener)
    throws AssemblyException
  {
    // may expect version and class attribute but it not used in JDK 
    // so we do either
    return context;
  }

  public Object getObject(String objectId)
  {
    return objectMap.get(objectId);
  }

  public void putObject(String objectId, Object o)
  {
    if (objectId != null)
      objectMap.put(objectId, o);
  }

  public Class instantiateClass(String className)
    throws ClassNotFoundException
  {
    return Class.forName(className, false, classLoader);
  }
}
