/*
 * Created on 27.09.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gnu.java.beans.decoder;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;

/** MethodContext collects arguments for a method call and creates the result object
 * using it. The method is called using the result object of the parent Context.
 *
 * When the result object is available methods can be called on it using sub-Contexts.
 *
 * @author Robert Schuster
 */
class MethodContext extends AbstractCreatableObjectContext
{
  private ArrayList arguments = new ArrayList();
  private String methodName;

  MethodContext(String id, String newMethodName)
  {
    setId(id);
    setStatement(true);
    methodName = newMethodName;
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#addObject(java.lang.Object)
   */
  public void addParameterObjectImpl(Object o)
  {
    arguments.add(o);
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#endContext(gnu.java.beans.decoder.Context)
   */
  protected Object createObject(Context outerContext)
    throws AssemblyException
  {
    Object outerObject = outerContext.getResult();

    if (outerObject == null)
      throw new AssemblyException(new NullPointerException("No object to invoke method "
                                                            + methodName));

    Object[] args = arguments.toArray();

    try
      {
	Method method = MethodFinder.getMethod(outerObject.getClass(),
	                                       methodName, args);
	return method.invoke(outerObject, args);
      }
    catch (NoSuchMethodException nsme)
      {
	throw new AssemblyException(nsme);
      }
    catch (InvocationTargetException ite)
      {
	throw new AssemblyException(ite.getCause());
      }
    catch (IllegalAccessException iae)
      {
	throw new AssemblyException(iae);
      }
  }
}
