/*
 * Created on 27.09.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */


package gnu.java.beans.decoder;


/** ObjectContext is a Context implementation that wraps a simple Object instance.
 * The instance can be provided when the Context is created (due to an 'idref'
 * attribute) or later (eg. <int> tag)
 *
 * The ObjectContext does not accept any parameter object and ignores notifications
 * about sub-Contexts being statements.
 *
 * @author Robert Schuster
 *
 */
final class ObjectContext extends AbstractObjectContext
{
  ObjectContext(Object newObject)
  {
    setObject(newObject);
  }

  ObjectContext(String id, Object newObject)
  {
    setId(id);
    setObject(newObject);
  }

  ObjectContext()
  {
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#addObject(java.lang.Object)
   */
  public void addParameterObject(Object o) throws AssemblyException
  {
    throw new AssemblyException(new IllegalArgumentException("Adding objects to an ObjectContext is not allowed."));
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#reportStatement()
   */
  public void notifyStatement(Context outerContext) throws AssemblyException
  {
    // can ignore that
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#endContext(gnu.java.beans.decoder.Context)
   */
  public Object endContext(Context outerContext) throws AssemblyException
  {
    // just returns the object which is encapsuled (may be null)
    return getResult();
  }

  /* (non-Javadoc)
   * @see gnu.java.beans.decoder.Context#subContextFailed()
   */
  public boolean subContextFailed()
  {
    // this context will not fail when a subcontext fails because the result is
    // already available when the context is created.
    return false;
  }
}
